#sccs	"@(#)adminbin:Backup.sh	1.12"
#                                                                Backup.sh
# PURPOSE: Backup system or files to floppy disk
# CALLED BY: Admin-kit
# REQUIRED FILES: Backup.menu Backusers.menu
# MODIFIED FILES: /etc/.lastbackup; .lastpartial
# ------------------------------------------------------------------------

ERROR1="An error has been encountered in the menu file Backup.menu\n  Please notify AT&T User Support.  Thank you."
ERROR2="An error has been encountered in the menu file Backuser.menu\n  Please notify AT&T User Support.  Thank you."
ERROR3="An error has been encountered during the backup.  Please make sure all your floppy disks are formatted and try again.\n"

ERROR4="You have a disk mounted already!\n\nPossible reasons: you have another Floppy window opened or you did a 'mount' on the system.  Please dismount the floppy disk by closing the 'Floppydisk' window or issue a 'dismount -f' in the 'Unix' window before attempting this operation."

ERRORWRITE="An error was encountered while writing to the floppy diskette(s).  Please be sure all your diskettes are formatted, and wait for the notification before removing them.  Please try again.  If this problem reoccurs at the same floppy, the disk may be bad."

LOCKFILE=/tmp/FinUse.lock
ERRINUSE="The floppy disk is already in use by another application.  Please wait for the disk to finish before starting again."

TERMCAP=
export TERMCAP
umask 022

trap "" 2

##  CHECK THAT FLOPPY IS NOT IN USE BY OTHER OPERATIONS.

if [ -s $LOCKFILE ]
then
	sh /usr/bin/Funlock.sh
	if [ $? != 0 ]
	then
		message -u "$ERRINUSE"
		exit
	fi
fi

##  CHECK THAT THE FLOPPY IS NOT MOUNTED.

DEVNUM=`mount | wc -l | cut -c7-7`
if [ "$DEVNUM" != "1" ]
then
	clear
	message -cu "$ERROR4"
	exit
fi

while true
do
	RET=`shform -u $UA/Backup.menu`
	if [ $? != 0 ] 
	then
		clear
		message -u "$ERROR1"
		exit
	fi
	set $RET
	if [ "$1" = "'Cancel'" ]
	then
		exit
	elif [ "$1" = "'Enter'" ]
	then
		break
	elif [ "$1" = "'Help'" ]
	then
		HELP="Backup"
		case "$2" in
		  "'Complete" )
			HELP="Complete Backup" ;;
		  "'Partial"  )
			HELP="Partial Backup" ;;
		  "'Backup"   )
			HELP="User Backup" ;;
		esac
		/usr/bin/uahelp -h $UA/admin.hlp -t "$HELP"
		clear
	fi
done
	
shift
RET1=$1
RET2=$2
RET3=$3

if [ \( "$RET1" = "'Complete" \) -o \( ! -s /etc/.lastbackup \) ]
then
	filename=/etc/.installdate
	file2=/etc/.lastbackup
else
	filename=/etc/.lastbackup
	file2=/etc/.lastpartial
fi
if [ "$RET3" != "user'" ]
then
	DIR=/
else
	cp $UA/Backuser.menu /tmp/umenu$$
	pwdmenu >> /tmp/umenu$$
	while true
	do
		clear
		URET=`shform -u /tmp/umenu$$`
		if [ $? != 0 ] 
		then
			clear
			message -u "$ERROR2"
			rm /tmp/umenu$$
			exit
		fi
		set $URET
		if [ "$1" = "'Cancel'" ]
		then
			rm /tmp/umenu$$
			exit
		elif [ "$1" = "'Enter'" ]
		then
			break
		elif [ "$1" = "'Help'" ]
		then
		       /usr/bin/uahelp -h $UA/admin.hlp -t "Backup"
		fi
	done
	rm /tmp/umenu$$
	eval USER=$2
	DIR=`pwdlogdir $USER`
fi

while true
do
clear
if [ \( "$DIR" = "/" \) -a \( "$filename" = "/etc/.installdate" \) ]
then
	set `df -t /`
	BLOCK1=`expr $8 - $3`
	BLOCKS=`expr $BLOCK1 - 4370`
	FLOPPYS=`expr $BLOCKS / 600`
	TIME=`expr ${FLOPPYS}0 / 8`
	message -cu "The backup will need about $FLOPPYS formatted floppy diskettes, and will take about $TIME minutes.\
  Please insert the first floppy diskette.  The floppy diskettes MUST\
 be formatted.  If you do not have enough formatted floppy disks, please press Cancel."
else
	message -cu "Insert the floppy disk to be used for this backup.  The floppy disk MUST be formatted.  If you do not have any formatted floppy disks, please press Cancel."
fi
if [ $? != 0 ] ; then exit; fi

# We have prompted user to insert floppy
# determine whether it's formatted
while true 
do
	FLOP=`iv -t /dev/rfp020 2>/dev/null | grep Partition`
	if [ $? != 0 ] 
	then
		dismount -f > /dev/null 2>&1
		clear
		message -cu "Cannot backup to the floppy disk.  Possible reasons include: disk has silver write-protect tab on it (remove tab); the floppy is not formatted; disk is not inserted or is inserted improperly; latch is not closed. Please check the floppy disk."
		if [ $? != 0 ] ; then exit ; fi
	else
		set $FLOP ; FLOP1=$1
		if [ $FLOP1 != Partition ]
		then
			clear
			message -cu "Floppy is not formatted.  Please use a formatted floppy disk and try again."
			if [ $? != 0 ] ; then exit; fi
		else
			break
		fi
	fi
done
#	use find with -newer option
if [ "$RET2" = "one" ]
then
	NEWER=
else
#	set up for an incremental update
#	assumption: date IN the file is the same as date OF the file
	NEWER="-newer $filename"
fi
clear
newwind
clear
echo " \n\n\n\n\n\n                         Backup in progress\n\n\n"

echo "$$ Backup.sh" > $LOCKFILE

trap "" 2
find $DIR $NEWER  -print |  cpio -oBc > /dev/rfp021 2>/tmp/cplog$$
if [ $? != 0 ] 
then
	trap 2
	dismount -f > /dev/null 2>&1
	clear
	message -cu "$ERRORWRITE"
	if [ $? != 0 ] ; then break; fi
else
	trap 2
	clear
	message -cu "Do you wish to check the information that was written on the floppy disk(s)?"
	CONFIRM=$?
	if [ $CONFIRM = 0 ]
	then
		clear
		message -iu "Please insert the first disk from this backup.\n\n  Touch ENTER to continue."

		clear
		newwind
		echo "\n\n\n\n\
             Checking data written to the floppy disk\n\n"
		cpio -ictB < /dev/rfp021 > /dev/null 2>&1
		if [ $? = 0 ]
		then
			echo "\n\n\
        Data written to the floppy disk is readable."
			sleep 3
		else
			dismount -f > /dev/null 2>&1
			clear
			message -cu "$ERRORWRITE"
			if [ $? != 0 ] ; then break; fi
		fi
	fi

	if [ \( "$NEWER" = "-newer /etc/.lastbackup" \) -a \( $DIR = "/" \) -a \( -s /etc/.lastbackup \) ]
	then
		set `cat -s  /etc/.lastbackup`
		clear
		message -iu "The partial backup of the files which have changed since the last complete backup, on $2 $3, is now finished.  In order to restore the system totally, \
first restore the last complete backup, and then restore the partial backup which you just finished.\n\n  Please touch Enter to continue."
	else
		clear
		message -iu "Backup is now complete.\n\n  Please touch Enter to continue."
	fi
	if [ "$DIR" = "/" ]
	then
		date > $file2
	fi

	# setup Backup.menu with last backup dates
	BDATE=`cat -s  /etc/.lastbackup`
	UDATE=`cat -s  /etc/.lastpartial`
	if [ -z "$BDATE" ]
	then
		COM="has not been done yet."
		PAR="has not been done yet."
		set `cat -s /etc/.installdate`
	elif [ -z "$UDATE" ]
	then
		set $BDATE
		COM="last done on $2 $3"
		PAR="has not been done yet."
	else 
		set $BDATE $UDATE
		COM="last done on $2 $3"
		PAR="last done on $8 $9"
	fi
	cat > $UA/Backup.menu << END
Menu = Partial Backup includes files changed since $2 $3
Label = Backup
Prompt =Complete Backup saves whole system, Partial Backup saves changed items.

Name = Complete Backup - $COM
Name = Partial Backup - $PAR
Name = Backup one user
END
	break

fi
done

rm -f $LOCKFILE
rm -f /tmp/cplog$$

# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                   Backup.sh
# =========================================================================
